﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Representation
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            var node5 = new Employee() { Name = "Node 5" };
            var node4 = new Employee() { Name = "Node 4", Subordinates = new ObservableCollection<Employee>() { node5 } };
            var node3 = new Employee() { Name = "Node 3", Subordinates = new ObservableCollection<Employee>() { node4 } };
            var node2 = new Employee() { Name = "Node 2", Subordinates = new ObservableCollection<Employee>() { node3 } };

            var snode5 = new Employee() { Name = "sNode 5" };
            var snode4 = new Employee() { Name = "sNode 4", Subordinates = new ObservableCollection<Employee>() { snode5 } };
            var snode3 = new Employee() { Name = "sNode 3", Subordinates = new ObservableCollection<Employee>() { snode4 } };
            var snode2 = new Employee() { Name = "sNode 2", Subordinates = new ObservableCollection<Employee>() { snode3 } };

            var snode1 = new Employee() { Name = "sNode 1", Subordinates = new ObservableCollection<Employee>() { snode2 } };
            var node1 = new Employee() { Name = "Node 1", Subordinates = new ObservableCollection<Employee>() { node2 } };
            var tnode1 = new Employee() { Name = "tNode" };
           

            myDiagram.ItemsSource = new[] { tnode1,snode1, node1 };                                                                                                        
        }

    }
    public class Employee : INotifyPropertyChanged
    {

        private string _name;

        public string Name 
        {
            get
            {
                return _name;
            }
            set 
            { 
                _name = value;
                OnPropertyChanged("Name"); 
            } 
        }

        private ObservableCollection<Employee> subordinates;

        public ObservableCollection<Employee> Subordinates 
        { 
            get { return subordinates; } 
            set { subordinates = value; }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName) 
        { if (PropertyChanged != null) 
            PropertyChanged(this, new PropertyChangedEventArgs(propertyName)); 
        }

    } 

}
